#!/bin/bash
dir="/var/www/html/upload"
dir1=$dir"/root/miner_data/heltec-snap"
#echo $dir1
exist_snap=$(ls $dir | grep heltec-snap- )
#echo $exist_snap
if [ "$exist_snap" != "" ]
then
	cd $dir
	docker stop miner &
	tar -zxf $exist_snap
	cd $dir1
	height=$(ls snap-* | awk -F- '{print $2}')
	height1=$(cat snapshotinfo | jq .block)
	if [ "$height" != "$height1" ]
	then
		echo "snapshot check failed"
		rm $dir/$exist_snap
		exit
	fi
	checksum=$(sha256sum $dir1/snap-$height | awk '{print $1}')
	checksum1=$(cat snapshotinfo | jq .sha256 | awk -F\" '{print $2}')
        if [ "$checksum" != "$checksum1" ]
        then
                echo "snapshot check failed"
                exit
        fi

	hash=$(cat snapshotinfo | jq .snapshot_hash | awk -F'<<' '{print $2}' | awk -F'>>' '{print $1}')
	hash1=$(cat snapshotinfo | jq .hash_hex | awk -F\" '{print $2}')

	hashlength=${#hash1}
	if [ "$hashlength" != "64" ]
	then
        	echo "snapshot check failed"
        	rm $dir/$exist_snap
		exit 
	fi

	error=0;
	for((i=1;i<=32;i++));
	do
        	tmp=$(echo $hash | awk -v i="$i" -F, '{print $i}')
        	n=`expr 2 \* $i - 2`
        	tmp1=${hash1:`expr 2 \* $i - 2`:2}
        	tmp1=$((16#$tmp1))
        	if [ "$tmp" != "$tmp1" ]
        	then
                	error=`expr $error + 1`
        	fi
	done
	#echo $error
	if [ "$error" != "0" ]
	then
		echo "snapshot check failed"
		rm $dir/$exist_snap
		exit
	else
	        echo "snap check OK"
	fi
	killall get_miner_conf.sh
	miner_conf_path="/root/miner_config/docker.config"
	cat /root/miner_config/docker_conf.start > $miner_conf_path

	if [ "$height" != "" ] && [ "$hash" != "" ] && [ "$height" != "null" ]
	then
#		echo "      {snap_source_base_url, \"127.0.0.1/upload/root/miner_data/heltec-snap\"}," >> $miner_conf_path
		echo "      {blessed_snapshot_block_height, $height}," >> $miner_conf_path
		echo "      {blessed_snapshot_block_hash, <<$hash>>}," >> $miner_conf_path
		echo "      {fetch_latest_from_snap_source, false}," >> $miner_conf_path
	fi
	docker stop miner
	cat /root/miner_config/docker_conf.end >> $miner_conf_path
	sync
	rm -rf /root/miner_data/
	DATADIR=/root/miner_data
	if [ ! -d $DATADIR ];then mkdir $DATADIR;fi
	mkdir /root/miner_data/snap
	mv $dir1/snap-$height /root/miner_data/snap
	rm $dir/$exist_snap
	rm -rf $dir/root
	docker start miner 
	sync
else
	echo "snapshot check failed"
fi
